import { AppComponent } from './app.component';
import { AppConfigService } from '@sec-spec/lib-ng-app-config';
import { BrowserModule } from '@angular/platform-browser';
import { HttpClientModule } from '@angular/common/http';
import { NgModule, APP_INITIALIZER } from '@angular/core';

// As of version 5.10.0, tslint cannot recognize decorators in
// association with this rule.
/* tslint:disable:completed-docs */

/* Main module for the wrapper application. */
@NgModule({
  bootstrap: [
    AppComponent,
  ],
  declarations: [
    AppComponent,
  ],
  imports: [
    BrowserModule,
    HttpClientModule,
  ],
  providers: [
    AppConfigService,
    {
      deps: [AppConfigService],
      multi: true,
      provide: APP_INITIALIZER,
      useFactory: appInitializerCallback,
    },
  ],
})
export class AppModule { }

/* tslint:enable:completed-docs */

/** Get callback function to load runtime application config data.
 * @param appConfig Service that loads the config data.
 * @returns Callback function.
 */
export function appInitializerCallback(appConfig: AppConfigService): Function {
  return () => {
    return appConfig.loadAppConfig();
  };
}
